


// Includes definitions relevant to the peripherals embedded in the digital signal controller.
#include "F2806x_Device.h"

#include "constants.h"

#include "hardware_interface.h"




// Definition of external functions. The bodies of the functions are in another file
extern int Initialize_the_Clocks(void);
extern int Initialize_the_GPIO(void);
extern int Initialize_the_Timer0(int);
extern int Enable_the_Peripherals(void);
extern int Manage_LEDs(int, int);
extern int Show_Character_on_Digit(char,int);

extern int Enable_the_Interrupts(void);

// Global variables are defined outside any function.
int Contatore=0;


#define CONTATORE1_INIZIALE 5000
#define CONTATORE2_INIZIALE 2000


// The program execution by default starts from the function called "main"
int main(void){

    int Rosso=0;
    int Contatore1=0;
    int Contatore2=0;

    int Digit=1;

    Enable_the_Peripherals();
    Initialize_the_Timer0(10);
    Initialize_the_Clocks();
    Initialize_the_GPIO();

    Enable_the_Interrupts();

    ATTIVA_IL_TIMER0;

    while (1) {


        while(Contatore1>0){
            Contatore1--;
            while(Contatore2>0){
                Contatore2--;
            }
            Contatore2=CONTATORE2_INIZIALE;


            if(Digit++>4){          // Incrementa Digit e poi verifica se  maggiore di 4
                Digit=1;
            }
            Show_Character_on_Digit('a',Digit);


        }
        Contatore1=CONTATORE1_INIZIALE;


        if(Rosso==0){
            Manage_LEDs(TURN_ON,RED);
            Manage_LEDs(TURN_OFF,BLUE);
            Rosso=1;
        }
        else{
            Manage_LEDs(TURN_OFF,RED);
            Manage_LEDs(TURN_ON,BLUE);
            Rosso=0;
        }



    }
}




interrupt void Timer0_isr(){

    if(BOTTONE_PREMUTO){
        ACCENDI_ROSSO;
        SPEGNI_BLU;
    }
    else{
        SPEGNI_ROSSO;
        ACCENDI_BLU;
    }

    RESETTA_IL_TIMER0;
    PieCtrlRegs.PIEACK.bit.ACK1=1;

}
